----------------------------------------------------------
-- Chat and speech bubbles
----------------------------------------------------------

local textboxcheck
local newmessage
local function ChatFilterHandler(self, event, message, sender, ...)
	local originalmessage=message
	message=TheHedgehog(message)	
	sender=TheHedgehog(sender)
	
	-- if the message type might have produced a speech bubble, start scanning for that too
	if(message~=originalmessage)then
		if(event=="CHAT_MSG_SAY" 
		or event=="CHAT_MSG_PARTY"	
		or event=="CHAT_MSG_PARTY_LEADER"
		or event=="CHAT_MSG_YELL"
		or event=="CHAT_MSG_MONSTER_SAY" 
		or event=="CHAT_MSG_MONSTER_PARTY"
		or event=="CHAT_MSG_MONSTER_YELL"
		or event=="CHAT_MSG_BOSS_EMOTE"
		)then
			textboxcheck=originalmessage
			newmessage=message
		end
	end
	return false, message, sender, ...
end

--SOURCE: us.battle.net/forums/en/wow/topic/14058435776
local function ScanChildren(...)
	for i=1,select("#",...) do
		local frame = select(i,...)
		if(not frame:IsForbidden())then
			local regions=frame:GetRegions()
			local numregions=frame:GetNumRegions()
			if not frame:GetName() and numregions  then
				--print("Possible chat bubble found:",frame,frame.name)
				RREGIONS=regions
				local selectframe=select(11,frame:GetRegions())
				if(selectframe.GetText)then
					local contents=selectframe:GetText()
					--print("Contents:",contents,"(comparing to",textboxcheck..")")
					if(contents==textboxcheck)then
						textboxcheck=nil		--found it!	 stop scanning

						local newtext=newmessage
						selectframe:SetText(newtext)
						
						local newwidth=string.len(newtext)*9
						if(newwidth>300)then newwidth=300 end
						selectframe:SetWidth(newwidth)
						local parent=frame:GetParent()			
end	end	end end end end

local timer=0
local f = CreateFrame("Frame")
--TODO: we can probably replace this with a C_Timer function that only runs when we're expecting a textbox
f:SetScript("OnUpdate",function(self,elapsed)
	if(textboxcheck)then
		timer = timer + elapsed
		if timer > 0.125 then
			timer = 0
			ScanChildren(WorldFrame:GetChildren())
end end end)

ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM",ChatFilterHandler); 	-- whispers sent from self to other
ChatFrame_AddMessageEventFilter("CHAT_MSG_SYSTEM",ChatFilterHandler);
ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY",ChatFilterHandler);
ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY",ChatFilterHandler);
ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY_LEADER",ChatFilterHandler);
ChatFrame_AddMessageEventFilter("CHAT_MSG_INSTANCE_CHAT",ChatFilterHandler);
ChatFrame_AddMessageEventFilter("CHAT_MSG_INSTANCE_CHAT_LEADER",ChatFilterHandler);
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID",ChatFilterHandler);
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_LEADER",ChatFilterHandler);
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_WARNING",ChatFilterHandler);
ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL",ChatFilterHandler);
ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER",ChatFilterHandler);
ChatFrame_AddMessageEventFilter("CHAT_MSG_GUILD",ChatFilterHandler);
ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL",ChatFilterHandler);
ChatFrame_AddMessageEventFilter("CHAT_MSG_EMOTE",ChatFilterHandler);
ChatFrame_AddMessageEventFilter("CHAT_MSG_TEXT_EMOTE",ChatFilterHandler);
ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL",ChatFilterHandler);
ChatFrame_AddMessageEventFilter("CHAT_MSG_BOSS_EMOTE",ChatFilterHandler);
ChatFrame_AddMessageEventFilter("CHAT_MSG_MONSTER_EMOTE",ChatFilterHandler);
ChatFrame_AddMessageEventFilter("CHAT_MSG_MONSTER_SAY",ChatFilterHandler);
ChatFrame_AddMessageEventFilter("CHAT_MSG_MONSTER_WHISPER",ChatFilterHandler);
ChatFrame_AddMessageEventFilter("CHAT_MSG_MONSTER_PARTY",ChatFilterHandler);
ChatFrame_AddMessageEventFilter("CHAT_MSG_MONSTER_YELL",ChatFilterHandler);


----------------------------------------------------------
-- "Talking heads" (world quest voiceover popup)
----------------------------------------------------------

local function TalkingHeadFrame_PlayCurrent_Hook()
	local text=TalkingHeadFrame.NameFrame.Name:GetText()
	text=TheHedgehog(text)
	TalkingHeadFrame.NameFrame.Name:SetText(text)

	local text=TalkingHeadFrame.TextFrame.Text:GetText()
	text=TheHedgehog(text)
	TalkingHeadFrame.TextFrame.Text:SetText(text)
end
--SOURCE: wowinterface.com/forums/showthread.php?t=55806
local function SetupTalkingHeadHook()
	hooksecurefunc('TalkingHeadFrame_PlayCurrent', TalkingHeadFrame_PlayCurrent_Hook)
end
if TalkingHeadFrame then
    HookTalkingHead()
else -- Hook to the loading function.
    hooksecurefunc('TalkingHead_LoadUI', SetupTalkingHeadHook)    
end


----------------------------------------------------------
-- Gossip, quests, and other frames
----------------------------------------------------------

-- calling SetText from within the SetText hook function requires a bit of effort
-- to avoid getting caught in an infinite loop.
local ignore_text=nil
local function SetText_Hook(self,text)
	--print("Called SetText_Hook from",self:GetName())
	--print("IllidanTheHedgehog ignore_text:",ignore_text)
	if(self==GameTooltip)then print("SetText_Hook",text) end
	if(self:IsForbidden())then return end	
	if(text)then
		if(text~=ignore_text)then
			local newtext=TheHedgehog(text)
			if(newtext~=text)then
				ignore_text=newtext
				self:SetText(newtext)
			end
		else
			--print("Ignored",self:GetName())
		end
	end	
end
hooksecurefunc(GossipFrameNpcNameText,"SetText",SetText_Hook)
hooksecurefunc(GossipGreetingText,"SetText",SetText_Hook)
hooksecurefunc(QuestFrameNpcNameText,"SetText",SetText_Hook)
hooksecurefunc(QuestInfoDescriptionText,"SetText",SetText_Hook)
hooksecurefunc(QuestProgressText,"SetText",SetText_Hook)
hooksecurefunc(QuestInfoRewardText,"SetText",SetText_Hook)
hooksecurefunc(CinematicFrame.Subtitle1,"SetText",SetText_Hook)
hooksecurefunc(QuestInfoObjectivesText,"SetText",SetText_Hook)
hooksecurefunc(TargetFrameTextureFrameName,"SetText",SetText_Hook)
hooksecurefunc(PlayerName,"SetText",SetText_Hook)
hooksecurefunc(SubZoneTextString,"SetText",SetText_Hook)

-- Nameplates are more difficult to hook -- they don't exist when the addon is loaded
-- Instead we hook into CreateFrame and detect when a nameplate is created
local nameplatecounter=0
local function CreateFrame_Hook(frameType,name,parent,template,d)	
	if(name=="$parentUnitFrame")then
		-- we're expecting "$parent" to convert to "NamePlate#" during CreateFrame
		if(_G["NamePlate"..tostring(nameplatecounter+1).."UnitFrame"])then
			nameplatecounter=nameplatecounter+1
			hooksecurefunc(_G["NamePlate"..tostring(nameplatecounter).."UnitFrame"].name,"SetText",SetText_Hook)
		end
	end
end
hooksecurefunc("CreateFrame",CreateFrame_Hook)

-- Finally, GameTooltip doesn't appear to call SetText on its own.
-- We can still hook OnTooltipSetUnit though
local function OnTooltipSetUnit_Hook(self)
	if(GameTooltipTextLeft1:IsForbidden())then return end
	local text=GameTooltipTextLeft1:GetText()
	newtext=TheHedgehog(text)
	if(text~=newtext)then
		GameTooltipTextLeft1:SetText(newtext)
	end
end
GameTooltip:HookScript("OnTooltipSetUnit",OnTooltipSetUnit_Hook)



----------------------------------------------------------
-- Text substitution
----------------------------------------------------------

function TheHedgehog(text)
	local startindex=0
	local endindex=0
	local newtext=text
	local lowertext=string.lower(text)
	-- Replace all instances of "Illidan" and "Illidan Stormrage" with "Illidan the Hedgehog".
	while true do		
		startindex,endindex=string.find(lowertext,"illidan",endindex+1)
		if startindex == nil then break end
		if(startindex)then
			local caps=string.sub(newtext,startindex,endindex)			
			local hedgehog=""
			-- Try to preserve some semblance of the original capitalization
			-- (e.g. if another player wrote "illidan")
			if(caps=="illidan")then hedgehog=" the hedgehog"
			elseif(caps=="Illidan")then hedgehog=" the Hedgehog"
			elseif(caps=="ILLIDAN")then hedgehog=" THE HEDGEHOG"
			elseif(caps=="iLLIDAN")then hedgehog=" THE hEDGEHOG"
			else hedgehog=" the Hedgehog" end						
			newtext=string.sub(newtext,1,endindex) .. hedgehog .. string.sub(newtext,endindex+1)			
			lowertext=string.sub(lowertext,1,endindex) .. hedgehog .. string.sub(lowertext,endindex+1)
		end		
	end
	
	local startindex=0
	local endindex=0
	local newtext=newtext
	local lowertext=string.lower(newtext)
	while true do		
		startindex,endindex=string.find(lowertext,"illidan the hedgehog stormrage",startindex+1)
		if startindex == nil then break end
		if(startindex)then
			local caps=string.sub(newtext,startindex,endindex)			
			local blank=""			
			newtext=string.sub(newtext,1,endindex-10) .. blank .. string.sub(newtext,endindex+1)
			lowertext=string.sub(lowertext,1,endindex-10) .. blank .. string.sub(lowertext,endindex+1)
		end		
	end	
	return newtext
end